//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                HandlingWithErrors.mqh |
//|                                                                                                                                   hoz |
//|                                                                                                                                       |
//+---------------------------------------------------------------------------------------------------------------------------------------+
#ifndef HANDLINGWITHERRORS_H
#define HANDLINGWITHERRORS_H
#ifndef WM_COMMAND
#define WM_COMMAND  0x0111
#endif

#property copyright "hoz"
#property link      ""
#property strict
// ==================================================      =================================================+
#import "user32.dll"
     int GetAncestor (int hWnd, int gaFlags);
     int PostMessageA (int hWnd, int Msg, int wParam, string lParam);
#import
#include    <HOZ_Code\Classes\Logging.mqh>
//+=======================================================================================================================================+
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                                      ,                                  |
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+=======================================================================================================================================+
class HandlingWithErrors
{
   private:
      //----
   public:
      //---- 
      string   ErrInf;        //      
      //----   
               HandlingWithErrors (void);
              ~HandlingWithErrors (void);
      //---- 
      bool     ErrorHandling (int fi_Error, bool& fb_InvalidSTOP);
      void     ReConnect();
      string   ErrorToString (int fi_Error);
      string   ErrorDescription (int fi_Error);
};
//---- C   HandlingWithErrors
HandlingWithErrors CErrs;
//=========================================================================================================================================
//  . ====================================================================================================================
HandlingWithErrors::HandlingWithErrors (void) {
}
//=========================================================================================================================================
//  . =====================================================================================================================
HandlingWithErrors::~HandlingWithErrors (void) {
}
//========================================================================================================================================
// 1.1   . ======================================================================================================
bool HandlingWithErrors::ErrorHandling (int fi_Error,                      //  
                                        bool &fb_InvalidSTOP)              //    "   "
{
//----
   if (fi_Error == 0)
       return (true);
      
   switch (fi_Error)
   {
      case    4:   /*ERR_SERVER_BUSY*/
      case  137:   /*ERR_BROKER_BUSY*/
      case  139:   /*ERR_ORDER_LOCKED*/
      case  146:   /*ERR_TRADE_CONTEXT_BUSY*/ Sleep (500); return (false);
      case    6:   /*ERR_NO_CONNECTION*/ ReConnect(); Sleep (1000); return (false);
      case  135:   /*ERR_PRICE_CHANGED*/ 
      case  136:   /*ERR_OFF_QUOTES*/
      case  138:   /*ERR_REQUOTE*/ Sleep (1); return (false);
      case  129:   /*ERR_INVALID_PRICE*/
      case  130:   /*ERR_INVALID_STOPS*/ fb_InvalidSTOP = true; return (false);
      case 4109:   /*ERR_TRADE_NOT_ALLOWED*/
         Print ("  !    \'  \'");
         return (true);
         
      default: CLogging.WriteLog (StringConcatenate ( " #", OrderTicket(), ",    ", fi_Error, " :: ", "[", ErrorDescription (fi_Error),"]"));
         return (true);
   }
//----
   return (true);
}
//=========================================================================================================================================
// 1.2     . ===========================================================================================
void HandlingWithErrors::ReConnect (void)
{
//----  Handle 
   int hMetaTrader = GetAncestor (WindowHandle (Symbol(), Period()), 2);
//----    
   if (hMetaTrader != 0)
   {
      PostMessageA (hMetaTrader, WM_COMMAND, 37400, NULL);
   }
//----
   return;
}
//=========================================================================================================================================
// 1.3        . ========================================================================================
string HandlingWithErrors::ErrorToString (int fi_Error)
{
   return (StringConcatenate ("  ", fi_Error, " :: ", ErrorDescription (fi_Error)) );
}
//=========================================================================================================================================
// 1.4        ,    . ====================================

string HandlingWithErrors::ErrorDescription (int fi_Error)
{
   string ls_Error = "";

   switch (fi_Error)
   {
      //  ,   :
      case 0    :   ls_Error = " ";
      case 1    :   ls_Error = " ,    ";
      case 2    :   ls_Error = " ";
      case 3    :   ls_Error = " ";
      case 4    :   ls_Error = "  ";
      case 5    :   ls_Error = "   ";
      case 6    :   ls_Error = "    ";
      case 7    :   ls_Error = " ";
      case 8    :   ls_Error = "  ";
      case 9    :   ls_Error = " ,   ";
      case 64   :   ls_Error = " ";
      case 65   :   ls_Error = "   ";
      case 128  :   ls_Error = "    ";
      case 129  :   ls_Error = " ";
      case 130  :   ls_Error = " ";
      case 131  :   ls_Error = " ";
      case 132  :   ls_Error = " ";
      case 133  :   ls_Error = " ";
      case 134  :   ls_Error = "    ";
      case 135  :   ls_Error = " ";
      case 136  :   ls_Error = " ";
      case 137  :   ls_Error = " ";
      case 138  :   ls_Error = " ";
      case 139  :   ls_Error = "    ";
      case 140  :   ls_Error = "  ";
      case 141  :   ls_Error = "  ";
      case 145  :   ls_Error = " , ..     ";
      case 146  :   ls_Error = "  ";
      case 147  :   ls_Error = "     ";
      case 148  :   ls_Error = "       ,  ";
      case 149  :   ls_Error = "     ,  ,   ";
      case 150  :   ls_Error = "         FIFO";
      //    MQL4-:
      case 4000 :   ls_Error = " ";
      case 4001 :   ls_Error = "  ";
      case 4002 :   ls_Error = "  -  ";
      case 4003 :   ls_Error = "    ";
      case 4004 :   ls_Error = "    ";
      case 4005 :   ls_Error = "      ";
      case 4006 :   ls_Error = "    ";
      case 4007 :   ls_Error = "    ";
      case 4008 :   ls_Error = " ";
      case 4009 :   ls_Error = "   ";
      case 4010 :   ls_Error = "    ";
      case 4011 :   ls_Error = "  ";
      case 4012 :   ls_Error = "    ";
      case 4013 :   ls_Error = "  ";
      case 4014 :   ls_Error = " ";
      case 4015 :   ls_Error = " ";
      case 4016 :   ls_Error = " ";
      case 4017 :   ls_Error = " DLL  ";
      case 4018 :   ls_Error = "   ";
      case 4019 :   ls_Error = "   ";
      case 4020 :   ls_Error = "     ";
      case 4021 :   ls_Error = "   ,   ";
      case 4022 :   ls_Error = " ";
      case 4050 :   ls_Error = "   ";
      case 4051 :   ls_Error = "   ";
      case 4052 :   ls_Error = "   ";
      case 4053 :   ls_Error = " ";
      case 4054 :   ls_Error = "  -";
      case 4055 :   ls_Error = "  ";
      case 4056 :   ls_Error = "  ";
      case 4057 :   ls_Error = "   ";
      case 4058 :   ls_Error = "   ";
      case 4059 :   ls_Error = "     ";
      case 4060 :   ls_Error = "  ";
      case 4061 :   ls_Error = "  ";
      case 4062 :   ls_Error = "   string";
      case 4063 :   ls_Error = "   integer";
      case 4064 :   ls_Error = "   double";
      case 4065 :   ls_Error = "    ";
      case 4066 :   ls_Error = "     ";
      case 4067 :   ls_Error = "    ";
      case 4099 :   ls_Error = " ";
      case 4100 :   ls_Error = "    ";
      case 4101 :   ls_Error = "  ";
      case 4102 :   ls_Error = "   ";
      case 4103 :   ls_Error = "   ";
      case 4104 :   ls_Error = "   ";
      case 4105 :   ls_Error = "    ";
      case 4106 :   ls_Error = "  ";
      case 4107 :   ls_Error = "      ";
      case 4108 :   ls_Error = "   ";
      case 4109 :   ls_Error = "  .    \"  \"   ";
      case 4110 :   ls_Error = "   .    ";
      case 4111 :   ls_Error = "   .    ";
      case 4200 :   ls_Error = "  ";
      case 4201 :   ls_Error = "   ";
      case 4202 :   ls_Error = "  ";
      case 4203 :   ls_Error = "  ";
      case 4204 :   ls_Error = "  ";
      case 4205 :   ls_Error = "  ";
      case 4206 :   ls_Error = "   ";
      case 4207 :   ls_Error = "    ";
   }

   return (ls_Error);
}

#endif